import React from 'react'
import PropTypes from 'prop-types'
import styled from 'styled-components'
import { icons } from 'wax-prosemirror-core'
import { color } from '../../../../../theme'

// Source: https://gitlab.coko.foundation/wax/wax-prosemirror/-/blob/master/wax-prosemirror-components/src/helpers/Icon.js
// modified to allow more icons, which can be defined like this:  https://gitlab.coko.foundation/wax/wax-prosemirror/-/blob/master/wax-prosemirror-components/src/icons/icons.js

const Svg = styled.svg.attrs(() => ({
  version: '1.1',
  xmlns: 'http://www.w3.org/2000/svg',
  xmlnsXlink: 'http://www.w3.org/1999/xlink',
}))`
  fill: ${color.gray60};
  height: 24px;
  vertical-align: top;
  width: 24px;
  &.active {
    background: ${color.gray90};
    // fill: ${color.gray30};
  }
`

const kotahiIcons = {
  citationList: ({ className }) => (
    <Svg className={className} fill="none" viewBox="0 0 24 24">
      <path d="M0 0h24v24H0z" fill="none" />
      <path d="M14 2H6c-1.1 0-1.99.9-1.99 2L4 20c0 1.1.89 2 1.99 2H18c1.1 0 2-.9 2-2V8l-6-6zm2 16H8v-2h8v2zm0-4H8v-2h8v2zm-3-5V3.5L18.5 9H13z" />
    </Svg>
  ),
  backMatter: ({ className }) => (
    <Svg className={className} viewBox="0 0 23 26">
      {className === 'active' ? (
        <path
          clipRule="evenodd"
          d="M8 4.34493V2.41714C8.24377 2.65871 8.50117 3.02544 8.76084 3.56687C9.36231 4.82099 9.80319 6.70738 10 9.02943V10.9875V13.9875V16.7232C9.78249 16.4187 9.5444 16.1428 9.28471 15.905C8.91232 15.564 8.48103 15.2904 8 15.137V4.39132C8.00036 4.37582 8.00036 4.36035 8 4.34493ZM10.5642 2.702C11.1324 3.8868 11.5418 5.4141 11.7966 7.14849C12.6918 6.40143 13.8246 5.98755 15 5.98755H22C22.5523 5.98755 23 6.43526 23 6.98755V21.9875C23 22.5398 22.5523 22.9875 22 22.9875H14C13.4696 22.9875 12.9609 23.1983 12.5858 23.5733C12.2107 23.9484 12 24.4571 12 24.9875C12 25.5398 11.5523 25.9875 11 25.9875C10.4477 25.9875 10 25.5398 10 24.9875C10 24.4571 9.78929 23.9484 9.41421 23.5733C9.03914 23.1983 8.53043 22.9875 8 22.9875H1C0.447715 22.9875 0 22.5398 0 21.9875V6.98755C0 6.43526 0.447715 5.98755 1 5.98755H3V3.98759C3 3.46505 3.40231 3.03061 3.9233 2.99053C4.51116 2.94531 5.23212 2.96605 6 3.09492V1.00638C6 0.483847 6.40231 0.0494053 6.9233 0.00932859C8.64914 -0.123428 9.83414 1.17984 10.5642 2.702ZM8.96744 18.9546L8.96144 18.9411C8.64072 18.2207 8.28316 17.6997 7.93404 17.38C7.59633 17.0708 7.31316 16.9866 7.07125 17.0038C6.79437 17.0236 6.52171 16.9274 6.31855 16.7382C6.11539 16.5491 6 16.284 6 16.0064V5.13095C5.65358 5.0558 5.31532 5.0099 5 4.98692V6.98755V17.9746C6.16481 18.0187 7.56909 18.2612 8.81811 18.8786C8.86812 18.9033 8.91791 18.9287 8.96744 18.9546ZM2 7.98755H3V18.9876C3 19.2652 3.11539 19.5303 3.31855 19.7195C3.52171 19.9086 3.79437 20.0048 4.07125 19.985C5.12287 19.9099 6.68097 20.0532 7.93189 20.6715C8.14236 20.7756 8.34324 20.892 8.5313 21.023C8.35615 20.9995 8.17869 20.9875 8 20.9875H2V7.98755ZM13.9316 10.7148V17.9876H16.8755C17.4319 17.9876 17.8935 17.9012 18.2605 17.7283C18.6274 17.5555 18.902 17.32 19.0843 17.0217C19.2666 16.721 19.3578 16.3825 19.3578 16.006C19.3578 15.6367 19.282 15.3219 19.1305 15.0614C18.979 14.801 18.7837 14.5998 18.5446 14.4577C18.3078 14.3133 18.0604 14.234 17.8024 14.2198V14.1488C18.0391 14.092 18.2534 13.9985 18.4451 13.8683C18.6369 13.738 18.7896 13.5688 18.9032 13.3604C19.0169 13.1497 19.0737 12.8964 19.0737 12.6005C19.0737 12.2406 18.9861 11.9187 18.8109 11.6346C18.6381 11.3505 18.3765 11.1268 18.0261 10.9634C17.6781 10.7977 17.2413 10.7148 16.7157 10.7148H13.9316ZM16.666 16.8867H15.2491V14.756H16.7015C16.9738 14.756 17.2082 14.8069 17.4047 14.9087C17.6011 15.0082 17.7527 15.1455 17.8592 15.3207C17.9657 15.4935 18.019 15.6876 18.019 15.9031C18.019 16.1919 17.9125 16.4286 17.6994 16.6133C17.4887 16.7956 17.1442 16.8867 16.666 16.8867ZM16.5524 13.8079H15.2491V11.8015H16.5808C16.969 11.8015 17.2614 11.8926 17.4579 12.0749C17.6568 12.2572 17.7562 12.4892 17.7562 12.771C17.7562 12.984 17.7029 13.1687 17.5964 13.3249C17.4922 13.4788 17.349 13.5984 17.1667 13.6836C16.9844 13.7665 16.7797 13.8079 16.5524 13.8079Z"
          fillRule="evenodd"
        />
      ) : (
        <g>
          <path
            clipRule="evenodd"
            d="M8 2.41714V4.34493C8.00036 4.36035 8.00036 4.37582 8 4.39132V15.137C8.48103 15.2904 8.91232 15.564 9.28471 15.905C9.5444 16.1428 9.78249 16.4187 10 16.7232V13.9875V10.9875V9.02943C9.80319 6.70738 9.36231 4.82099 8.76084 3.56687C8.50117 3.02544 8.24377 2.65871 8 2.41714ZM11.7966 7.14849C11.5418 5.4141 11.1324 3.8868 10.5642 2.702C9.83414 1.17984 8.64914 -0.123428 6.9233 0.00932859C6.40231 0.0494053 6 0.483847 6 1.00638V3.09492C5.23212 2.96605 4.51116 2.94531 3.9233 2.99053C3.40231 3.03061 3 3.46505 3 3.98759V5.98755H1C0.447715 5.98755 0 6.43526 0 6.98755V21.9875C0 22.5398 0.447715 22.9875 1 22.9875H8C8.53043 22.9875 9.03914 23.1983 9.41421 23.5733C9.78929 23.9484 10 24.4571 10 24.9875C10 25.5398 10.4477 25.9875 11 25.9875C11.5523 25.9875 12 25.5398 12 24.9875C12 24.4571 12.2107 23.9484 12.5858 23.5733C12.9609 23.1983 13.4696 22.9875 14 22.9875H22C22.5523 22.9875 23 22.5398 23 21.9875V6.98755C23 6.43526 22.5523 5.98755 22 5.98755H15C13.8246 5.98755 12.6918 6.40143 11.7966 7.14849ZM12 10.9875V13.9875V21.5234C12.6029 21.1754 13.2918 20.9875 14 20.9875H21V7.98755H15C14.2044 7.98755 13.4413 8.30362 12.8787 8.86623C12.3161 9.42884 12 10.1919 12 10.9875ZM8.96144 18.9411L8.96744 18.9546C8.91791 18.9287 8.86812 18.9033 8.81811 18.8786C7.56909 18.2612 6.16481 18.0187 5 17.9746V6.98755V4.98692C5.31532 5.0099 5.65358 5.0558 6 5.13095V16.0064C6 16.284 6.11539 16.5491 6.31855 16.7382C6.52171 16.9274 6.79437 17.0236 7.07125 17.0038C7.31316 16.9866 7.59633 17.0708 7.93404 17.38C8.28316 17.6997 8.64072 18.2207 8.96144 18.9411ZM3 7.98755H2V20.9875H8C8.17869 20.9875 8.35615 20.9995 8.5313 21.023C8.34324 20.892 8.14236 20.7756 7.93189 20.6715C6.68097 20.0532 5.12287 19.9099 4.07125 19.985C3.79437 20.0048 3.52171 19.9086 3.31855 19.7195C3.11539 19.5303 3 19.2652 3 18.9876V7.98755Z"
            fillRule="evenodd"
          />
          <path d="M13.9316 18.0005V10.7278H16.7157C17.2413 10.7278 17.6781 10.8106 18.0261 10.9764C18.3765 11.1397 18.6381 11.3634 18.8109 11.6475C18.9861 11.9316 19.0737 12.2536 19.0737 12.6134C19.0737 12.9094 19.0169 13.1627 18.9032 13.3734C18.7896 13.5817 18.6369 13.751 18.4451 13.8812C18.2534 14.0114 18.0391 14.1049 17.8024 14.1617V14.2328C18.0604 14.247 18.3078 14.3263 18.5446 14.4707C18.7837 14.6127 18.979 14.814 19.1305 15.0744C19.282 15.3348 19.3578 15.6497 19.3578 16.019C19.3578 16.3954 19.2666 16.7339 19.0843 17.0346C18.902 17.3329 18.6274 17.5685 18.2605 17.7413C17.8935 17.9141 17.4319 18.0005 16.8755 18.0005H13.9316ZM15.2491 16.8997H16.666C17.1442 16.8997 17.4887 16.8085 17.6994 16.6262C17.9125 16.4416 18.019 16.2048 18.019 15.916C18.019 15.7006 17.9657 15.5064 17.8592 15.3336C17.7527 15.1584 17.6011 15.0211 17.4047 14.9217C17.2082 14.8199 16.9738 14.769 16.7015 14.769H15.2491V16.8997ZM15.2491 13.8208H16.5524C16.7797 13.8208 16.9844 13.7794 17.1667 13.6965C17.349 13.6113 17.4922 13.4918 17.5964 13.3379C17.7029 13.1816 17.7562 12.997 17.7562 12.7839C17.7562 12.5022 17.6568 12.2702 17.4579 12.0879C17.2614 11.9056 16.969 11.8144 16.5808 11.8144H15.2491V13.8208Z" />
        </g>
      )}
    </Svg>
  ),
  frontMatter: ({ className }) => (
    <Svg className={className} viewBox="0 0 22 26">
      {className === 'active' ? (
        <path
          clipRule="evenodd"
          d="M14 2.41714V4.34494C13.9996 4.36036 13.9996 4.37582 14 4.39131V15.137C13.519 15.2904 13.0877 15.564 12.7153 15.905C12.4556 16.1428 12.2175 16.4187 12 16.7232V13.9875V10.9875V9.02943C12.1968 6.70738 12.6377 4.82099 13.2392 3.56687C13.4988 3.02544 13.7562 2.65871 14 2.41714ZM10.2034 7.14849C10.4582 5.4141 10.8676 3.8868 11.4358 2.702C12.1659 1.17984 13.3509 -0.123428 15.0767 0.00932859C15.5977 0.0494053 16 0.483847 16 1.00638V3.09492C16.7679 2.96605 17.4888 2.94531 18.0767 2.99053C18.5977 3.03061 19 3.46505 19 3.98759V5.98755H21C21.5523 5.98755 22 6.43526 22 6.98755V21.9875C22 22.5398 21.5523 22.9875 21 22.9875H14C13.4696 22.9875 12.9609 23.1983 12.5858 23.5733C12.2107 23.9484 12 24.4571 12 24.9875C12 25.5398 11.5523 25.9875 11 25.9875C10.4477 25.9875 10 25.5398 10 24.9875C10 24.4571 9.78929 23.9484 9.41421 23.5733C9.03914 23.1983 8.53043 22.9875 8 22.9875H1C0.447715 22.9875 0 22.5398 0 21.9875V6.98755C0 6.43526 0.447715 5.98755 1 5.98755H7C8.17542 5.98755 9.30816 6.40143 10.2034 7.14849ZM16 16.0064V5.13095C16.3464 5.0558 16.6847 5.0099 17 4.98692V6.98755V17.9746C15.8352 18.0187 14.4309 18.2612 13.1819 18.8786C13.1319 18.9033 13.0821 18.9287 13.0326 18.9546L13.0386 18.9411C13.3593 18.2207 13.7168 17.6997 14.066 17.38C14.4037 17.0708 14.6868 16.9866 14.9287 17.0038C15.2056 17.0236 15.4783 16.9274 15.6814 16.7382C15.8846 16.5491 16 16.284 16 16.0064ZM19 7.98755V18.9876C19 19.2652 18.8846 19.5303 18.6814 19.7195C18.4783 19.9086 18.2056 20.0048 17.9287 19.985C16.8771 19.9099 15.319 20.0532 14.0681 20.6715C13.8576 20.7756 13.6568 20.892 13.4687 21.023C13.6439 20.9995 13.8213 20.9875 14 20.9875H20V7.98755H19ZM3.93652 17.9876V11.4421H8.27033V12.5831H5.3204V14.1428H7.98269V15.2838H5.3204V17.9876H3.93652Z"
          fillRule="evenodd"
        />
      ) : (
        <path
          clipRule="evenodd"
          d="M14 4.34445V2.41666C13.7562 2.65822 13.4988 3.02495 13.2392 3.56639C12.6377 4.82051 12.1968 6.7069 12 9.02894V10.9871V13.987V16.7227C12.2175 16.4183 12.4556 16.1423 12.7153 15.9045C13.0877 15.5635 13.519 15.2899 14 15.1365V4.39082C13.9996 4.37533 13.9996 4.35987 14 4.34445ZM11.4358 2.70151C10.8676 3.88631 10.4582 5.41361 10.2034 7.148C9.30816 6.40094 8.17542 5.98706 7 5.98706H1C0.447715 5.98706 0 6.43478 0 6.98706V21.9871C0 22.5393 0.447715 22.9871 1 22.9871H8C8.53043 22.9871 9.03914 23.1978 9.41421 23.5728C9.78929 23.9479 10 24.4566 10 24.9871C10 25.5393 10.4477 25.9871 11 25.9871C11.5523 25.9871 12 25.5393 12 24.9871C12 24.4566 12.2107 23.9479 12.5858 23.5728C12.9609 23.1978 13.4696 22.9871 14 22.9871H21C21.5523 22.9871 22 22.5393 22 21.9871V6.98706C22 6.43478 21.5523 5.98706 21 5.98706H19V3.9871C19 3.46456 18.5977 3.03012 18.0767 2.99004C17.4888 2.94482 16.7679 2.96556 16 3.09443V1.00589C16 0.483359 15.5977 0.048917 15.0767 0.00884031C13.3509 -0.123916 12.1659 1.17936 11.4358 2.70151ZM10 13.987V21.5229C9.39709 21.1749 8.70823 20.9871 8 20.9871H2V7.98706H7C7.79565 7.98706 8.55871 8.30313 9.12132 8.86574C9.68393 9.42835 10 10.1914 10 10.9871V13.987ZM16 5.13046V16.0059C16 16.2835 15.8846 16.5486 15.6814 16.7378C15.4783 16.9269 15.2056 17.0231 14.9287 17.0034C14.6868 16.9861 14.4037 17.0703 14.066 17.3795C13.7168 17.6992 13.3593 18.2202 13.0386 18.9406L13.0326 18.9541C13.0821 18.9282 13.1319 18.9028 13.1819 18.8781C14.4309 18.2607 15.8352 18.0182 17 17.9741V6.98706V4.98643C16.6847 5.00942 16.3464 5.05531 16 5.13046ZM19 18.9871V7.98706H20V20.9871H14C13.8213 20.9871 13.6439 20.999 13.4687 21.0225C13.6568 20.8915 13.8576 20.7751 14.0681 20.671C15.319 20.0527 16.8771 19.9094 17.9287 19.9846C18.2056 20.0043 18.4783 19.9081 18.6814 19.719C18.8846 19.5298 19 19.2647 19 18.9871ZM3.93652 11.4417V17.9871H5.3204V15.2833H7.98269V14.1423H5.3204V12.5826H8.27033V11.4417H3.93652Z"
          fillRule="evenodd"
        />
      )}
    </Svg>
  ),

  ...icons,
}

const SVGIcon = props => {
  const { className, name } = props
  const Component = kotahiIcons[name]
  return <Component className={className} />
}

SVGIcon.propTypes = {
  name: PropTypes.string.isRequired,
  className: PropTypes.string,
}

SVGIcon.defaultProps = { className: '' }

export default SVGIcon
